/*------------------------------------------------------------------------------
 | All Rights Reserved, Copyright (c) Reo MIZOGUCHI(mizoguchi@javable.jp) 2005 
 | project : jp.javable
 | filename: JavableFileAppender.java
 | Date       Version  Author          Changes key
 | 2005/12/31   0.0.1  R.MIZOGUCHI     Create
 +----------------------------------------------------------------------------*/
package jp.javable.sample.log4j;

import java.io.IOException;

import org.apache.log4j.FileAppender;
import org.apache.log4j.Layout;
import org.apache.log4j.RollingFileAppender;

public class JavableFileAppender extends RollingFileAppender {
    
    /**
     * RXgN^łB
     */
    public JavableFileAppender() {
        super();
        setFile(getFile());
    }

    /**
     * RXgN^łB
     * 
     * @param layout CAEgIuWFNg
     * @param filename o̓Ot@C
     * @throws IOException IOOꍇ
     */
    public JavableFileAppender(Layout layout, String filename) throws IOException {
        super(layout, filename);
        setFile(getFile());
    }

    /**
     * RXgN^łB
     * 
     * @param layout CAEgIuWFNg
     * @param filename o̓Ot@C
     * @param append Ot@CɒǋL邩ǂ̃tO
     * @throws IOException IOOꍇ
     */
    public JavableFileAppender(Layout layout, String filename, boolean append)
            throws IOException {
        super(layout, filename, append);
        setFile(getFile());
    }
    
    
    /**
     * JVM ̋Ni-Dlog.file.namejt@C擾郁\bhłB
     * {@link FileAppender#getFile()}I[o[Ch܂B
     * 
     * @see org.apache.log4j.FileAppender#getFile()
     */
    public String getFile() {
        String filename = System.getProperty("log.file.name");
        if (filename == null) {
            filename = super.getFile();
        }
        return filename == null ? "" :  filename;
    }
}
